<?php
/*
Plugin Name: ChloroAttachment for WordPress
Plugin URI: http://martincl2.me/archives/365
Description: SAE Storage 附件上传，代替原版WordPress的附件上传功能以兼容SAE环境
Version: beta 1
Author: Martin Chloride
Author URI: http://martincl2.me
*/

/*  Copyright 2013  Martin Chloride  (email : i@martincl2.me)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

namespace SAE\attachment;
define('SAE_STORAGE', 'wordpress');
define('SAE_DIR', 'saestor://'.SAE_STORAGE);
define('SAE_URL', 'http://'.$_SERVER['HTTP_APPNAME'].'-'.SAE_STORAGE.'.stor.sinaapp.com/uploads');
define('SAE_TMP_DIR_STORAGE', \SAE_TMP_PATH.'storage');

\add_action('init', 'SAE\attachment\init');

function init(){
	$action = \basename($_SERVER['SCRIPT_FILENAME']);
	switch ($action)
	{
		case 'update.php':
		case 'update-core.php':
			break;
			
		default:
			\add_filter('upload_dir', 'SAE\attachment\upload_dir');
			\add_filter('wp_handle_upload', 'SAE\attachment\handle_upload');
			\add_filter('wp_generate_attachment_metadata', 'SAE\attachment\upload_thumb', 999);
			\add_filter('wp_delete_file', 'SAE\attachment\delete_file');
			break;
	}
}

function upload_dir($uploads){
	$uploads['basedir'] = SAE_TMP_DIR_STORAGE;
	$uploads['baseurl'] = SAE_URL;
	$uploads['path'] = SAE_TMP_DIR_STORAGE.$uploads['subdir'];
	$uploads['url'] = SAE_URL.$uploads['subdir'];
	
	return $uploads;
}

function handle_upload($file){
	$filename = \str_replace(SAE_TMP_DIR_STORAGE.'/', '', $file['file']);
	
	$s = new \SaeStorage();
	$s->upload(SAE_STORAGE, 'uploads/'.$filename, $file['file']);
	
	return $file;
}

function upload_thumb($metadata){
	if(isset($metadata['sizes'])){
		$dir = SAE_TMP_DIR_STORAGE.'/'.dirname($metadata['file']);
		$s = new \SaeStorage();
		foreach($metadata['sizes'] as $size_name => $image_meta){
			$file = $image_meta['file'];
			$s->upload(SAE_STORAGE, 'uploads/'.dirname($metadata['file']).'/'.$image_meta['file'], $dir.'/'.$image_meta['file']);
		}
	}
	return $metadata;
}

function delete_file($file){
	$url_pos = \strpos($file, '/storage/');
	if($url_pos !== false){
		$file = \substr($file, $url_pos + 9);
	}
	$file = 'uploads/'.$file;
	
	$s = new \SaeStorage();
	$result = $s->delete(SAE_STORAGE, $file);
	return $file;
}
?>